<template>
<!-- eslint-disable vue/no-use-v-if-with-v-for -->
  <!-- DETAILED MONSTER CONTAINER -->
  <div class="detail-page">
      <div class="monster-name-container">
        {{currentMonster.name}}
      </div>
      <div class="monster-detailed-container">
          <div class="monster-image">
            <img 
            v-if="currentMonster.type != 'swarm of Tiny beasts'"
            :src="`https://mk0thealpinedmusc1ub.kinstacdn.com/wp-content/uploads/2020/09/${currentMonster.type.charAt(0).toUpperCase() + currentMonster.type.slice(1)}.png`"/>
            <img 
            v-if="currentMonster.type == 'swarm of Tiny beasts'"
            src="https://mk0thealpinedmusc1ub.kinstacdn.com/wp-content/uploads/2020/09/Beast.png"/>
            <div class="monster-type-area">{{currentMonster.type}}</div>
          </div>
        <div class="main-monster-specs-area">
          <div class="monster-specs">
            <div class="monster-specs-global-style"><label>SIZE</label> {{currentMonster.size}}</div>
            <div class="monster-specs-global-style"><label>ARMOR</label> {{currentMonster.armor_class}}</div>
            <div class="monster-specs-global-style"><label>HP</label> {{currentMonster.hit_points}}</div>
            <div class="monster-specs-global-style"><label>HIT DICE</label> {{currentMonster.hit_dice}}</div>
            <div class="monster-specs-global-style"><label>SPEED</label> {{currentMonster.speed.walk}}</div>
            <div class="monster-specs-global-style"><label>RATE</label> {{currentMonster.challenge_rating}}</div>
            <div class="monster-specs-global-style"><label>STRENGTH</label> {{currentMonster.strength}}</div>
            <div class="monster-specs-global-style"><label>DEXTERITY</label> {{ currentMonster.dexterity }}</div>
            <div class="monster-specs-global-style"><label>INTELLIGENCE</label> {{ currentMonster.intelligence }}</div>
            <div class="monster-specs-global-style"><label>WISDOM</label> {{ currentMonster.wisdom }}</div>
            <div class="monster-specs-global-style"><label>CHARISMA</label> {{ currentMonster.charisma }}</div>
            <div class="monster-specs-global-style"><label>CONSTITUTION</label> {{ currentMonster.constitution }}</div>
            <!-- SPECIAL ABILLITIES CONTAINER -->
            <div class="detailed-container-style" v-if="currentMonster.special_abilities">
              <div class="title-area">Special Abillities</div>
              <ul>
                <li v-for="ability in currentMonster.special_abilities" :key="ability.index">
                  <div class="detailed-area-style">{{ ability.name }}</div>
                  <div class="detailed-desc-area">{{ ability.desc }}</div>
                </li>
              </ul>
            </div>
            <!-- ACTION ABILLITIES CONTAINER -->
            <div class="detailed-container-style" v-if="currentMonster.actions">
              <div class="title-area">Actions</div>
              <ul>
                <li v-for="(action, index) in currentMonster.actions" :key="index ">
                  <div class="detailed-area-style">{{ action.name }}</div>
                  <div class="detailed-desc-area">{{ action.desc }}</div>
                </li>
              </ul>
            </div>
          </div>
        </div>
      </div>
      <!-- LIST OF MONSTERS WITH THE SAME TYPE -->
      <div class="same-type-monster-list-container" v-if="hideSameTypeMonsterList">
        <label>Same Type Monters</label>
        <ul class="same-type-monster-list" >
            <li @click="refreshList()" 
                v-for="(monster, index) in sameTypeMonsterList" 
                :key="index" v-if="sameTypeMonsterList"
                class="same-type-monster">
              <router-link id="router" :to="monster.index" >
                <div>{{ monster.name }}</div>
                <div class="same-type-monster-detail">
                  <div><i class="fas fa-shield-alt"></i>
                    {{ monster.armor_class }}
                  </div>
                  <div><i class="fas fa-heartbeat"></i>
                    {{ monster.hit_points }}
                  </div>
                  <div><i class="fas fa-dice-d20"></i>
                    {{ monster.hit_dice }}
                  </div>
                </div>
              </router-link>
            </li>
        </ul>
      </div>
  </div>
</template>

<script lang="ts">

import Vue from "vue";
import MonstersListService from "@/services/MonstersListService";
import Monster from "@/types/Monster";

export default Vue.extend({

  data() {
    return {
      monsters: [] as Monster[],
      currentMonster: {} as Monster,
      currentIndex: -1,
      setMonstersList: [{}],
      sameTypeMonsterList: [{}],
      hideSameTypeMonsterList: false,
      test: 0
    }
  },

  methods: {
    // FORCE REFRESH TO LOAD SELECTED MONSTER
    refreshList() {
      window.location.reload();
    },
    // GET SELECTED MONSTER DATA
    getMonsterSelectedDetails(index: any) {
      MonstersListService.monsterSelected(index)
      .then((results) => {
        this.currentMonster = results.data
      })
    },
    // GET LIST OF MONSTERS WITH THE SAME TYPE
    getMonstersTypeLsit() {
      const monstersList: any[] = []
      MonstersListService.getAll()
        .then((response) => {
          this.monsters = response.data.results.map((index: any) => index.index)
          for(let i = 0; i < this.monsters.length; i++) {
            MonstersListService.get(this.monsters[i])
            .then((monstersResults) => {
              if(monstersResults.data.type == this.currentMonster.type) {
                if(monstersResults.data.index != this.currentMonster.index) {
                  monstersList.push(monstersResults.data)
                  monstersList.length < 1 ? this.hideSameTypeMonsterList : this.hideSameTypeMonsterList = true
                  this.sameTypeMonsterList = monstersList
                }
              }
            })
          }
        })
    }
  },

   mounted() {
     this.getMonsterSelectedDetails(this.$route.params.index)
     this.getMonstersTypeLsit()
   }

})
</script>

<style scoped>

.detail-page {
  position: relative;
}

.monster-name-container {
  position: relative;
  padding: 0.5em;
  margin: 0.5em;
  height: 2em;
  border-left: 0.125em solid #7a0000;
  border-bottom: 0.125em solid #7a0000;
  border-radius: 0.5em;
  border-top-left-radius: 0.1em;
  border-bottom-right-radius: 0.1em;
  font-size: 2.5em;
  font-weight: bold;
  letter-spacing: 0.75em;
  user-select: none;
  text-transform: uppercase;
}

.monster-detailed-container {
  display: flex;  
  margin: 1.5em;
  margin-top: 2.5em;
  min-height: 40em;
  background-color: #7a0000;
  background-image: url("https://www.transparenttextures.com/patterns/black-thread.png");  
  border-radius: 0.5em;
  color: #ffff;
  font-weight: bold;
  user-select: none;
  font-size: 1em;
}

.monster-image {
  display: flex;
  flex-direction: column;
  justify-content: center;
  padding-left: 0.5em;
  padding-right: 0.5em;
  margin: 1em;
  background-color: #ffffff;
  border-radius: 0.5em;
}

.monster-type-area {
  padding: 1em;
  margin-top: 1.5em;
  background-color: #000000;
  border-radius: 0.5em;
  text-transform: uppercase;
}

.main-monster-specs-area {
  display: flex;
  flex-direction: column;
  width: 100%;
}

.monster-specs {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  justify-content: center;
  align-items: center;
  margin: 1em;
  height: 100%;
  background-color: #ffffff;
  border-radius: 0.5em;
  overflow: auto;
}

.monster-specs-global-style {
  display: flex;
  flex-direction: column;
  justify-content: center;
  margin: 1em;
  width: 10em;
  height: 4em;
  background-color: #000000;
  border-radius: 0.5em;
}

.detailed-container-style {
  padding-top: 2em;
  margin-top: 2em;
  width: 95%;
  border-top: solid 0.1em #000000;
}

.title-area {
  margin-bottom: 1em;
  color: #000000;
  font-size: 1.5em;
}

ul {
  display: flex;
  flex-direction: column;
  padding: 0;
  margin: 0;
  list-style-type: none;
}

li {
  display: flex;
  flex-direction: row;
  margin-bottom: 0.75em;
}

.detailed-area-style {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  padding: 0.75em;
  margin-right: 1em;
  width: 14em;
  max-height: 6.5em;
  background-color: #000000;
  border-radius: 0.5em;
}

.detailed-desc-area {
  display: flex;
  justify-content: center;
  padding: 0.75em;
  width: 100%;
  max-height: 6.5em;
  background-color: #000000;
  border-radius: 0.5em;
  overflow-y: auto;
  font-size: 1em;
}

.same-type-monster-list-container {
  display: flex;
  flex-direction: column;
  padding-top: 1em;
  margin: 1em;
  margin-top: 2.5em;
  min-height: 9em;
  max-height: 14em;
  border: 0.125em solid #7a0000;
  border-radius: 0.5em;
  color: #7a0000;
  font-weight: bold;
  overflow: auto;
  user-select: none;
}

.same-type-monster-list-container {
  font-size: 1.25em;
}

#router {
  text-decoration: none;
  color: inherit;
}

.same-type-monster-list {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  justify-content: center;
}

.same-type-monster {
  display: flex;
  flex-direction: column;
  justify-content: center;
  margin: 0.5em;
  width: 13em;
  height: 5em;
  background-color: #7a0000;
  background-image: url("https://www.transparenttextures.com/patterns/black-thread.png");
  border-radius: 0.5em;
  color: #ffffff;
  font-size: 0.90em;
}

.same-type-monster-detail {
  display: flex;
  flex-direction: row;
  justify-content: center;
}

.same-type-monster-detail div {
  margin: 0.5em;
}

/* DYNAMIC STYLE AREA */

@media only screen and (max-width: 1024px) {

  .monster-detailed-container {
    display: flex; 
    flex-direction: column; 
    margin: 1em;
    margin-top: 0.5em;
    overflow: auto;
  }

  .monster-image {
    display: flex;
    flex-direction: row;
    align-items: center;
  }

  .monster-image img {
    width: 6em;
    margin: 0.5em;
    margin-right: 3em;
  }

  .monster-type-area {
    margin-top: 0;
    font-size: 1.5em;
  }

  .monster-specs {
    margin: 1em;
    margin-top: 0.4em;
    font-size: 1.5em;
  }

  .detailed-container-style {
    font-size: 1.25em;
  }

  li {
    display: flex;
    flex-direction: row;
    flex-wrap: wrap;
    justify-content: center;
  }

  .title-area {
    font-size: 1.5em;
  }

  .detailed-area-style {
    margin: 0.25em;
  }

  .detailed-desc-area {
    display: flex;
    justify-content: center;
    margin: 0.25em;
    margin-bottom: 0.75em;
    font-size: 1em;
  }


  .same-type-monster {
    width: 18em;
    font-size: 1.25em;
  }
}

</style>